import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;

public class Blatt extends JPanel implements MouseMotionListener, MouseListener
{
	private int xMov=-1;
	private int yMov=-1;
	private int xAnfang=-1;
	private int yAnfang=-1;
	private int xEnde=-1;
	private int yEnde=-1;
	public boolean fadenkreuz;
	private int breite=getToolkit().getScreenSize().width;
	private int hhe=getToolkit().getScreenSize().height;
	private boolean defaultgre=true;

	public Blatt(Vector figuren)
	{
		fadenkreuz=false;
		this.figuren=figuren;
		addMouseMotionListener(this);
		addMouseListener(this);
		this.setDoubleBuffered(true);
	}

	public void lscheFadenkreuz()
	{
		xMov=-1;
		yMov=-1;
		xAnfang=-1;
		yAnfang=-1;
		xEnde=-1;
		yEnde=-1;
		repaint();
	}

	public void setFlche(int breite, int hhe)
	{
		this.breite=breite;
		this.hhe=hhe;
		defaultgre=false;
	}

	public void paint(Graphics g)
	{
		Graphics2D g2d=(Graphics2D) g;
		g2d.setColor(Color.lightGray);
		g2d.fillRect(0, 0, getSize().width, getSize().height);
		for(int i=0;i<figuren.size();i++)
		{
			((Figur)figuren.elementAt(i)).paint(g2d);
		}

//********************************************************************		Fadenkreuz
		g.setColor(Color.gray);
		g.drawLine(xAnfang,0,xAnfang,hhe);
		g.drawLine(0,yAnfang,breite,yAnfang);
		g.drawLine(xEnde,0,xEnde,hhe);
		g.drawLine(0,yEnde,breite,yEnde);

		g.setColor(Color.darkGray);
		g.drawLine(xMov,0,xMov,hhe);
		g.drawLine(0,yMov,breite,yMov);

//********************************************************************		Rahmen
		g.setColor(Color.gray);

		int br,h;
		if(defaultgre)
		{
			br=getSize().width;
			h=getSize().height;
		}
		else
		{
			br=Math.min(breite,getSize().width);
			h=Math.min(hhe,getSize().height);
		}

		g.fillRect(0,0,10,h);
		g.fillRect(br-10,0,br,h);
		g.fillRect(0,0,br,10);
		g.fillRect(0,h-10,br,h);
		Figur.blattbreite=br;
		Figur.blatthhe=h;

		g.setColor(Color.white);

		if(br<getSize().width)
		{
			g.fillRect(br,0,getSize().width-br,getSize().height);
		}
		if(h<getSize().height)
		{
			g.fillRect(0,h,getSize().width,getSize().height-h);
		}

	}
	public void mouseDragged(MouseEvent e)
	{
		if(fadenkreuz)
		{
			xMov=e.getX();
			yMov=e.getY();
			repaint();
		}
	}
	public void mouseMoved(MouseEvent e)
	{
		if(fadenkreuz)
		{
			xMov=e.getX();
			yMov=e.getY();
			repaint();
		}
	}
	public void mouseClicked(MouseEvent e){}
	public void mousePressed(MouseEvent e)
	{
		if(fadenkreuz)
		{
			xAnfang=e.getX();
			yAnfang=e.getY();
		}
	}
	public void mouseReleased(MouseEvent e)
	{
		if(fadenkreuz)
		{
			xEnde=e.getX();
			yEnde=e.getY();
		}
	}
	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e)
	{
		xMov=-1;
		yMov=-1;
		if(!fadenkreuz)
		{
			xAnfang=-1;
			yAnfang=-1;
			xEnde=-1;
			yEnde=-1;
		}
		repaint();
	}

	private Image dbImage;
	private Graphics dbGraphics;
	private Vector figuren;
}

