import java.awt.*;
import java.util.*;
import java.awt.geom.*;

public abstract class Figur
{
	protected Bild bild;
	protected int xmin, ymin, xmax, ymax;
	private boolean sichtbar=true;
	private float winkel=0;
	private int vx,vy;
	private int vfall,vhpf;
	private int omega=0;
	private int unten=0;
	public Color farbe;
	private static int nummer=0;
	private Vector argumente;
	private Vector methoden;
	public int linienbreite=0;
	private Argument[] argArray;
	private Methode[] metArray;
	private Thread thW, thR, thF, thH;
	private boolean goW, goH, goR, goF;
	public static int blattbreite=1000;
	public static int blatthhe=1000;
	private int drehX=0;
	private int drehY=0;
	private boolean autodrehpunkt=true;
	public static int faktor=100;
	private static float faktorW=10;

	public Figur()
	{
		Bild.addElement(this);
		argumente=new Vector();
		methoden=new Vector();
		argumente.add(new Argument("farbe","grau","Farbe des Objekts"));

		addMet(new Methode("verschiebe(nachRechts,nachUnten)","verschiebt das Objekt - auch negative Werte sind erlaubt"));
		addMet(new Methode("drehe(Winkel)","dreht das Objekt gegen den Uhrzeigersinn"));
		addMet(new Methode("setzeDrehpunkt(links,oben)","setzt den Drehpunkt des Objekts - gemessen von den Bildrndern"));
		addMet(new Methode("wandere(nachRechts,nachUnten)","setzt das Objekt in Bewegung - grere Werte entsprechen greren Geschwindigkeiten"));
		addMet(new Methode("stopWanderung()","Beendet wandere()"));
		addMet(new Methode("rotiere(Drehgeschwindigkeit)","dreht das Objekt immer weiter"));
		addMet(new Methode("stopRotation()","beendet rotiere()"));
		addMet(new Methode("falle()","lsst das Objekt mit zunehmender Geschwindigkeit nach unten fallen"));
		addMet(new Methode("stopFall()","beendet falle()"));
		addMet(new Methode("hpfe(Boden)","lsst das Objekt hpfen - Boden ist der Abstand des Bodens vom oberen Rand"));
		addMet(new Methode("stopHpfen()","beendet hpfe()"));
		addMet(new Methode("nachVorne()","rckt die Figur eins nach vorne"));
		addMet(new Methode("inDenVordergrund()","setzt die Figur ganz nach vorne"));
		addMet(new Methode("nachHinten()","rckt die Figur eins nach hinten"));
		addMet(new Methode("inDenHintergrund()","setzt die Figur ganz nach hinten"));
		addMet(new Methode("ausblenden()","macht die Figur unsichtbar"));
		addMet(new Methode("einblenden()","macht die Figur wieder sichtbar"));
	
		metArray = new Methode[methoden.size()];
		Object[] tmpM=methoden.toArray();
		for(int i=0;i<methoden.size();i++)
		{
			metArray[i]=(Methode)tmpM[i];
		}
	}

	public void addArg(Argument a)
	{
		argumente.add(a);
	}

	public void addMet(Methode m)
	{
		methoden.add(m);
	}

	public static int getNummer()
	{
		return nummer;
	}
	public static void incNummer()
	{
		nummer++;
	}

	public void setBild(Bild bild)
	{
		this.bild=bild;
	}

	public void setzeDrehpunkt(int x, int y)
	{
		drehX=x;
		drehY=y;
		autodrehpunkt=false;
	}

	public Argument[] getArguments()
	{
		if(argArray==null)
		{
			argArray = new Argument[argumente.size()];
			Object[] tmp=argumente.toArray();
			for(int i=0;i<argumente.size();i++)
			{
				argArray[i]=(Argument)tmp[i];
			}
		}
		return argArray;
	}
	public Methode[] getMethods()
	{
		return metArray;
	}

	public void drehe(int winkel)
	{
		this.winkel-=winkel;
		if(bild!=null)
		{
			bild.neu();
		}
	}
	public void ausblenden()
	{
		sichtbar=false;
	}
	public void einblenden()
	{
		sichtbar=true;
	}

	public void falle()
	{
		vfall=0;
		goF=true;
		setGrenzen();
		RunAdapter r=new RunAdapter(){public void run()
		{
			while( goF & ymin<blatthhe )
			{
				verschiebe(0,(int)(vfall++/3));
				setGrenzen();
				if(bild!=null)
				{
					bild.neu();
				}
				try{Thread.currentThread().sleep(100);}catch(Exception e){}
			}
		}};
		thF=new Thread(r);
		thF.start();
	}

	public void hpfe(int u)
	{
		unten=u;
		vhpf=0;
		goH=true;
		setGrenzen();
		RunAdapter r=new RunAdapter(){public void run()
		{
			while( goH )
			{
				vhpf++;
				verschiebe(0,(int)(vhpf/3));
				setGrenzen();
				if(ymax>unten)			//blatthhe
				{
					vhpf=-vhpf-1;
				}
				if(bild!=null)
				{
					bild.neu();
				}
				try{Thread.currentThread().sleep(30);}catch(Exception e){}
			}
		}};
		thH=new Thread(r);
		thH.start();
	}

	public void wandere(int x, int y)
	{
		goW=true;
		this.vx=x;
		this.vy=y;
		if(vx!=0|vy!=0)
		{
			setGrenzen();
			RunAdapter r=new RunAdapter(){public void run()
			{
				while( goW & ( (vx>0&xmin<blattbreite) | (vx<0&xmax>0) | (vy>0&ymin<blatthhe) | (vy<0&ymax>0) ) )
				{
					verschiebe1(vx,vy);
					setGrenzen();
					if(bild!=null)
					{
						bild.neu();
					}
					try{Thread.currentThread().sleep(100);}catch(Exception e){}
				}
			}};
			thW=new Thread(r);
			thW.start();
		}
	}

	public void rotiere(int w)
	{
		omega=w;
		goR=true;
		RunAdapter r=new RunAdapter(){public void run()
		{
			while(goR)
			{
				winkel-=omega/faktorW;
				if(bild!=null)
				{
					bild.neu();
				}
				try{Thread.currentThread().sleep(100);}catch(Exception e){}
			}
		}};
		thR=new Thread(r);
		thR.start();
	}

	public Dimension getDrehpunkt()
	{
		if(autodrehpunkt)
		{
			return getMittelpunkt();
		}
		else
		{
			return new Dimension(drehX, drehY);
		}
	}

	public void inDenVordergrund()
	{
		RunAdapter r=new RunAdapter(){public void run()
		{
			while(bild==null)
			{
				try{Thread.currentThread().sleep(100);}catch(Exception e){}
			}
			idv();
		}};
		Thread thx=new Thread(r);
		thx.start();
	}
	private void idv()
	{
		bild.inDenVordergrund(this);
	}

	public void inDenHintergrund()
	{
		RunAdapter r=new RunAdapter(){public void run()
		{
			while(bild==null)
			{
				try{Thread.currentThread().sleep(100);}catch(Exception e){}
			}
			idh();
		}};
		Thread thx=new Thread(r);
		thx.start();
	}
	private void idh()
	{
		bild.inDenHintergrund(this);
	}
	public void nachVorne()
	{
		RunAdapter r=new RunAdapter(){public void run()
		{
			while(bild==null)
			{
				try{Thread.currentThread().sleep(100);}catch(Exception e){}
			}
			nv();
		}};
		Thread thx=new Thread(r);
		thx.start();
	}
	private void nv()
	{
		bild.nachVorne(this);
	}
	public void nachHinten()
	{
		RunAdapter r=new RunAdapter(){public void run()
		{
			while(bild==null)
			{
				try{Thread.currentThread().sleep(100);}catch(Exception e){}
			}
			nh();
		}};
		Thread thx=new Thread(r);
		thx.start();
	}
	private void nh()
	{
		bild.nachHinten(this);
	}
	
	public void stopBewegung(){stopWanderung();stopHpfen();stopRotation();stopFall();}
	public void stopWanderung(){goW=false;}
	public void stopRotation()
	{
		goR=false;
		Dimension ort=getDrehpunkt();
		int x0=ort.width;
		int y0=ort.height;
		autodrehpunkt=true;
		Dimension ist=getDrehpunkt();
		int xa=ist.width;
		int ya=ist.height;
		int dx=xa-x0;
		int dy=ya-y0;
		double w=Math.toRadians(winkel);
		int xb=x0+(int)(dx*Math.cos(w)-dy*Math.sin(w));
		int yb=y0+(int)(dy*Math.cos(w)+dx*Math.sin(w));
		verschiebe(xb-xa,yb-ya);
	}
	public void stopFall(){goF=false;}
	public void stopHpfen(){goH=false;}

	public void paint (Graphics2D g)
	{
		if(sichtbar)
		{
			g.setColor(farbe);
			Shape s=getShape();
			int x=getDrehpunkt().width;
			int y=getDrehpunkt().height;

			AffineTransform t1=new AffineTransform();
			t1.setToTranslation(-x,-y);
			AffineTransform t2=new AffineTransform();
			t2.rotate(Math.toRadians(winkel));
			AffineTransform t3=new AffineTransform();
			t3.setToTranslation(x,y);
			t1.preConcatenate(t2);
			t1.preConcatenate(t3);

			Shape tr=t1.createTransformedShape(s);
			g.fill(tr);
			if(linienbreite>0)
			{
				g.setStroke(new BasicStroke(linienbreite,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER));
				g.draw(tr);
				g.setStroke(new BasicStroke(1,BasicStroke.CAP_ROUND,BasicStroke.JOIN_MITER));
			}
		}
	}
	public abstract Shape getShape();
	public abstract Dimension getMittelpunkt();
	public abstract void verschiebe(int x, int y);
	public abstract void verschiebe1(int x, int y);
	public abstract void setGrenzen();
}
